"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _View = _interopRequireDefault(require("react-native-web/dist/exports/View"));

var _Text = _interopRequireDefault(require("react-native-web/dist/exports/Text"));

var _StyleSheet = _interopRequireDefault(require("react-native-web/dist/exports/StyleSheet"));

var _typography = require("../../typography");

var _styles = require("quark-core/styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

var Breadcrumbs = function Breadcrumbs(_ref) {
  var style = _ref.style,
      childrenProp = _ref.children,
      divider = _ref.divider,
      unused = _objectWithoutProperties(_ref, ["style", "children", "divider"]);

  var children = React.Children.toArray(childrenProp); // the divider between elements

  var divide = divider || React.createElement(_Text.default, {
    style: styles.divider
  }, ">"); // add the divider after every child

  var childs = children.map(function (child, i) {
    return React.createElement(_View.default, {
      style: styles.level,
      key: i
    }, React.createElement(_View.default, null, child), React.createElement(_View.default, {
      style: styles.dividerContainer
    }, i !== children.length - 1 && divide));
  });
  return React.createElement(_View.default, _extends({
    style: [styles.container, style]
  }, unused), childs);
};

var styles = _StyleSheet.default.create({
  container: {
    flexDirection: 'row',
    alignItems: 'center',
    justifyContent: 'flex-start'
  },
  level: {
    flexDirection: 'row'
  },
  dividerContainer: {
    display: 'flex',
    justifyContent: 'center',
    alignItems: 'center',
    marginLeft: 2 * _styles.baseDim,
    marginRight: 2 * _styles.baseDim
  },
  divider: {
    fontSize: 6 * _styles.baseDim,
    color: _styles.grey5
  }
});

var _default = Breadcrumbs;
exports.default = _default;