"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Monospace = exports.Link = exports.Text = exports.Subtitle = exports.Title = exports.H3 = exports.H2 = exports.H1 = void 0;

var React = _interopRequireWildcard(require("react"));

var _Text = _interopRequireDefault(require("react-native-web/dist/exports/Text"));

var _TextPropTypes = _interopRequireDefault(require("react-native-web/dist/exports/TextPropTypes"));

var _quarkCore = require("quark-core");

var _styles = require("quark-core/styles");

var _styles2 = _interopRequireDefault(require("./styles"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

// this component assigns the default value to text based on theme
var InnerText = function InnerText(_ref) {
  var style = _ref.style,
      unused = _objectWithoutProperties(_ref, ["style"]);

  return React.createElement(_quarkCore.GetTheme, null, function (_ref2) {
    var grey5 = _ref2.grey5;
    return React.createElement(_Text.default, _extends({
      style: _extends({
        color: grey5
      }, _styles2.default.reset, style)
    }, unused));
  });
};

var H1 = function H1(_ref3) {
  var style = _ref3.style,
      unused = _objectWithoutProperties(_ref3, ["style"]);

  return React.createElement(InnerText, _extends({
    style: _extends({}, _styles.h1, _styles2.default.h1, style)
  }, unused));
};

exports.H1 = H1;

var H2 = function H2(_ref4) {
  var style = _ref4.style,
      unused = _objectWithoutProperties(_ref4, ["style"]);

  return React.createElement(InnerText, _extends({
    style: _extends({}, _styles.h2, _styles2.default.h2, style)
  }, unused));
};

exports.H2 = H2;

var H3 = function H3(_ref5) {
  var style = _ref5.style,
      unused = _objectWithoutProperties(_ref5, ["style"]);

  return React.createElement(InnerText, _extends({
    style: _extends({}, _styles.h3, _styles2.default.h3, style)
  }, unused));
};

exports.H3 = H3;

var Title = function Title(_ref6) {
  var style = _ref6.style,
      unused = _objectWithoutProperties(_ref6, ["style"]);

  return React.createElement(InnerText, _extends({
    style: _extends({}, _styles.title, _styles2.default.title, style)
  }, unused));
};

exports.Title = Title;

var Subtitle = function Subtitle(_ref7) {
  var style = _ref7.style,
      unused = _objectWithoutProperties(_ref7, ["style"]);

  return React.createElement(InnerText, _extends({
    style: _extends({}, _styles.subtitle, _styles2.default.subtitle, style)
  }, unused));
};

exports.Subtitle = Subtitle;

var Text = function Text(_ref8) {
  var style = _ref8.style,
      unused = _objectWithoutProperties(_ref8, ["style"]);

  return React.createElement(InnerText, _extends({
    style: _extends({}, _styles.text, _styles2.default.text, style)
  }, unused));
};

exports.Text = Text;

var Link = function Link(_ref9) {
  var style = _ref9.style,
      unused = _objectWithoutProperties(_ref9, ["style"]);

  return React.createElement(InnerText, _extends({
    style: _extends({}, _styles.link, _styles2.default.link, style)
  }, unused));
};

exports.Link = Link;

var Monospace = function Monospace(_ref10) {
  var style = _ref10.style,
      unused = _objectWithoutProperties(_ref10, ["style"]);

  return React.createElement(InnerText, _extends({
    style: _extends({}, _styles.monospace, _styles2.default.monospace, style)
  }, unused));
};

exports.Monospace = Monospace;